package desCrypt;

public class createKey {
	
	private byte[][] PC_1 = new byte[8][7];
	private byte[][] PC_2 = new byte[8][6];
	private byte[] leftKey = new byte[28];
	private byte[] rightKey = new byte[28];
	
	public createKey(byte[][] InputKey){
		/**
		 * set Permuted Choice One (PC-1)
		 * */
		int k=7, l=0;
		for(int j=0;j<4;j++){
			for(int i=0;i<7;i++){
				PC_1[j][i]=InputKey[k--][l];
				if(k<0){
					l++;
					k=7;
				}
			}
		}
		k=7; l=6;
		for(int j=4;j<8;j++){
			for(int i=0;i<7;i++){
				if(j==7 && i==3)
					k=3;
				PC_1[j][i]=InputKey[k--][l];
				if(k<0){
					l--;
					k=7;
				}
			}
		}
	}
	
	/**
	 * Generate leftKey
	 * */
	public void leftKey(){
		int k=0,l=0;
		for(int j=0;j<28;j++){
			leftKey[j] = PC_1[k][l++];
			if(l==7){
				k++;
				l=0;
			}
		}
	}
	
	/**
	 * Generate rightKey
	 * */
	public void rightKey(){
		int k=4, l=0;
		for(int j=0;j<28;j++){
			rightKey[j] = PC_1[k][l++];
			if(l==7){
				k++;
				l=0;
			}
		}
	}

	/**
	 * shift Left Key
	 * */
	public void shiftKey(int cnt){
		byte[] output1 = new byte[28];
		byte[] output2 = new byte[28];
		
		output1[27] = leftKey[0];
		output2[27] = rightKey[0];
		for(int j=0;j<27;j++){
			output1[j] = leftKey[j+1];
			output2[j] = rightKey[j+1];
		}
		rightKey = output2;
		leftKey = output1;
		if(cnt>1){
			for(int i=1;i<cnt;i++)
				shiftKey(cnt-1);
		}
	}
	
	/**
	 * shift Right Key
	 * */
	public byte[] shiftRightKey(int cnt){
		byte[] output = new byte[28];
		for(int i=0;i<cnt;i++){
			for(int j=0;j<27;j++){
				output[j] = rightKey[j+1];
			}
			output[27] = rightKey[0];
			rightKey = output;
		}
		return output;
	}
	
	/**
	 * shift Left Key
	 * */
	public byte[] shiftLeftKey(int cnt){
		byte[] output = new byte[28];
		for(int i=0;i<cnt;i++){
			for(int j=0;j<27;j++){
				output[j] = leftKey[j+1];
			}
			output[27] = leftKey[0];
			leftKey = output;
		}
		return output;
	}
	
	/**
	 * merge rightKey & leftKey
	 * */
	public byte[][] mergeKey(){
		byte[][] output = new byte[8][7];
		int k=0;
		for(int j=0;j<4;j++){
			for(int i=0;i<7;i++){
				output[j][i] = leftKey[k++];
			}
		}
		k=0;
		for(int j=4;j<8;j++){
			for(int i=0;i<7;i++){
				output[j][i] = rightKey[k++];
			}
		}
		return output;
	}
	
	/**
	 * return the leftKey value
	 * */
	public byte[] getLeftKey(){
		return leftKey;
	}

	/**
	 * return the rightKey value
	 * */
	public byte[] getRightKey(){
		return rightKey;
	}

	/**
	 * return the PC-1 value
	 * */
	public byte[][] getPC_1(){
		return PC_1;
	}
	
	/**
	 * return the PC-2 value
	 * */
	public byte[][] getPC_2(){
		byte[][] merge = new byte[8][7];
		merge = mergeKey();
		
		/**
		 * generate PC-2
		 * */
		// 1 row
		PC_2[0][0] = merge[1][6];	//#14
		PC_2[0][1] = merge[2][2];	//#17
		PC_2[0][2] = merge[1][3];	//#11
		PC_2[0][3] = merge[3][2];	//#24
		PC_2[0][4] = merge[0][0];	//#1
		PC_2[0][5] = merge[0][4];	//#5
		
		//2row
		PC_2[1][0] = merge[0][2];	//#3
		PC_2[1][1] = merge[3][6];	//#28
		PC_2[1][2] = merge[2][0];	//#15
		PC_2[1][3] = merge[0][5];	//#6
		PC_2[1][4] = merge[2][6];	//#21
		PC_2[1][5] = merge[1][2];	//#10
		
		//3row
		PC_2[2][0] = merge[3][1];	//#23
		PC_2[2][1] = merge[2][4];	//#19
		PC_2[2][2] = merge[1][4];	//#12
		PC_2[2][3] = merge[0][3];	//#4
		PC_2[2][4] = merge[3][4];	//#26
		PC_2[2][5] = merge[1][0];	//#8

		//4row
		PC_2[3][0] = merge[2][1];	//#16
		PC_2[3][1] = merge[0][6];	//#7
		PC_2[3][2] = merge[3][5];	//#27
		PC_2[3][3] = merge[2][5];	//#20
		PC_2[3][4] = merge[1][5];	//#13
		PC_2[3][5] = merge[0][1];	//#2
		
		//5row
		PC_2[4][0] = merge[5][5];	//#41
		PC_2[4][1] = merge[7][2];	//#52
		PC_2[4][2] = merge[4][2];	//#31
		PC_2[4][3] = merge[5][1];	//#37
		PC_2[4][4] = merge[6][4];	//#47
		PC_2[4][5] = merge[7][5];	//#55

		//6row
		PC_2[5][0] = merge[4][1];	//#30
		PC_2[5][1] = merge[5][4];	//#40
		PC_2[5][2] = merge[7][1];	//#51
		PC_2[5][3] = merge[6][2];	//#45
		PC_2[5][4] = merge[4][4];	//#33
		PC_2[5][5] = merge[6][5];	//#48
		
		//7row
		PC_2[6][0] = merge[6][1];	//#44
		PC_2[6][1] = merge[6][6];	//#49
		PC_2[6][2] = merge[5][3];	//#39
		PC_2[6][3] = merge[7][6];	//#56
		PC_2[6][4] = merge[4][5];	//#34
		PC_2[6][5] = merge[7][3];	//#53
		
		//8row
		PC_2[7][0] = merge[6][3];	//#46
		PC_2[7][1] = merge[5][6];	//#42
		PC_2[7][2] = merge[7][0];	//#50
		PC_2[7][3] = merge[5][0];	//#36
		PC_2[7][4] = merge[4][0];	//#29
		PC_2[7][5] = merge[4][3];	//#32
		
		return PC_2;
	}
	
	/**
	 * 48bit PC2  Ki 64bit 
	 * */
	public byte[][] get64bitPC_2(byte[][] input){
		byte[][] output = new byte[8][8];
		
		for(int j=0;j<8;j++){
			for(int i=0;i<8;i++){
				if(i==0 || i==1)
					output[j][i] = 0;
				else
					output[j][i] = input[j][i-2];
			}
		}
		return output;
	}
	
	/**
	 * binary to Hex(64bit) 2迭
	 * */
	public String getHex(byte[][] input){
		//byte[] temp = new byte[64];
		String bin ="";
		String hex = "";
		int k=0,l=0;
		for(int j=0;j<64;j++){
			bin = bin+input[k][l++];
			//temp[j] = input[k][l++];
			if(l==8){
				k++;
				l=0;
			}
		}
		try{
			hex = Long.toHexString(Long.parseLong(bin,2));
		}catch(Exception e){
			System.err.println(e);
		}
		return hex;
	}
	
}
