package desCrypt;

public class main {

	/**
	 * Plain Text
	 * */
	private static byte[][] InputArray = {
		{0,0,0,0, 0,0,1,0},		//#1
		{0,1,0,0, 0,1,1,0},		//#2
		{1,0,0,0, 1,0,1,0},		//#3
		{1,1,0,0, 1,1,1,0},		//#4
		{1,1,1,0, 1,1,0,0},		//#5
		{1,0,1,0, 1,0,0,0},		//#6
		{0,1,1,0, 0,1,0,0},		//#7
		{0,0,1,0, 0,0,0,0}		//#8
	};
	
	/**
	 * Key
	 * */
	private static byte[][] InputKey = {
		{0,0,0,0, 1,1,1,1},		//#1
		{0,0,0,1, 0,1,0,1},		//#2
		{0,1,1,1, 0,0,0,1},		//#3
		{1,1,0,0, 1,0,0,1},		//#4
		{0,1,0,0, 0,1,1,1},		//#5
		{1,1,0,1, 1,0,0,1},		//#6
		{1,1,1,0, 1,0,0,0},		//#7
		{0,1,0,1, 1,0,0,1}		//#8
	};

	private static roundTrip r = new roundTrip(InputArray);
	private static createKey k = new createKey(InputKey);
	private static byte[][] PC_1 = new byte[8][7];
	private static int round_cnt=0;
	
	public static void main(String[] args) {

		byte[][] IP_Inv = new byte[8][8];
		PC_1 = k.getPC_1();
		
		/**
		 * divide left & right
		 * */
		k.leftKey();
		k.rightKey();
		/*
		System.out.println("IP");
		for(int j=0;j<8;j++){
			for(int i=0;i<8;i++){
				System.out.print(r.getIP()[j][i]);
			}
			
		}
		*/
		/**
		 * Start
		 * */
		System.out.println("Generate Key Process!!!");
		
		/**
		 * processing 16 Rounds
		 * */
		process(1);
		process(1);
		process(2);
		process(2);
		
		process(2);
		process(2);
		process(2);
		process(2);

		process(1);
		process(2);
		process(2);
		process(2);

		process(2);
		process(2);
		process(2);
		process(1);
		
		/**
		 * print Last IP
		 * */
		System.out.println("\n Last left IP(L16)");
		System.out.print(r.getHex(r.getLeftIP()));
		System.out.println("\n Last right IP(R16)");
		System.out.print(r.getHex(r.getRightIP()));
		System.out.println();

		/**
		 * set the Ciphertext
		 * */
		r.setIP_Inverse();
		IP_Inv = r.getIP_Inverse();
		for(int j=0;j<8;j++){
			for(int i=0;i<8;i++){
				System.out.print(IP_Inv[j][i]);
			}
			System.out.print(" ");
		}
		/**
		 * print Ciphertext
		 * */
		System.out.println("\n Ciphertext : "+r.getHex64(IP_Inv));
	}
	
	/**
	 * shift process
	 * */
	public static void process(int cnt){

		byte[][] IP = new byte[8][8];
		byte[] tempLeftKey = new byte[28];
		byte[] tempRightKey = new byte[28];
		byte[][] tempMergeKey = new byte[8][6];
		byte[][] temp64MergeKey = new byte[8][8];
		
		byte[] tempLeftIP = new byte[32];
		byte[] tempRightIP = new byte[32];
		byte[][] tempExpansion = new byte[8][6];
		byte[][] tempXor = new byte[8][6];
		
		/**
		 * 1 °
		 * */
		System.out.println("Process #"+(++round_cnt));
		
		k.shiftKey(cnt);
		/**
		 * set about Key
		 * */
		tempLeftKey = k.getLeftKey();
		tempRightKey = k.getRightKey();
		/**
		 * print left & right Key
		 * */
		System.out.println("left Key(C"+(round_cnt-1)+") : " );
		for(int j=0;j<28;j++)
			System.out.print(tempLeftKey[j]);
		System.out.println();
		
		System.out.println("right Key(D"+(round_cnt-1)+") : ");
		for(int j=0;j<28;j++)
			System.out.print(tempRightKey[j]);
		System.out.println();
		
		tempMergeKey= k.getPC_2();
		temp64MergeKey = k.get64bitPC_2(tempMergeKey);
		
		/**
		 * set about IP
		 * */
		tempLeftIP = r.getLeftIP();
		tempRightIP = r.getRightIP();
		
		/**
		 * print left & right IP
		 * */
		System.out.println("left IP(L"+(round_cnt)+") : ");
		for(int j=0;j<32;j++)
			System.out.print(tempLeftIP[j]);
		System.out.println();

		System.out.println("right IP(R"+(round_cnt)+") : " );
		for(int j=0;j<32;j++)
			System.out.print(tempRightIP[j]);
		System.out.println();
		
		r.setExpansion();
		tempExpansion = r.getExpansion();
		
		System.out.println("\nExpansion(E"+round_cnt+") : ");
		for(int j=0;j<8;j++){
			for(int i=0;i<6;i++){
				System.out.print(tempExpansion[j][i]);
			}
			System.out.print(" ");
		}
		System.out.println();
//		
//		System.out.println("PC2("+round_cnt+") : ");
//		for(int j=0;j<8;j++){
//			//System.out.print("#"+(j+1)+" : ");
//			for(int i=0;i<6;i++){
//				System.out.print(tempMergeKey[j][i]);
//			}
//			System.out.print(" ");
//		}
//		System.out.println();
		
		tempXor=r.setRi(tempMergeKey);

		System.out.println("after (R"+(round_cnt)+") : ");
		for(int j=0;j<8;j++){
			for(int i=0;i<4;i++){
				System.out.print(tempXor[j][i]);
			}
			System.out.print(" ");
		}
		System.out.println();
		System.out.println("Hex after R Value(R"+(round_cnt)+") : "+r.getHex(tempXor));
		System.out.println();
		
		System.out.println("merge 64bit Key(K"+round_cnt+") : ");
		for(int j=0;j<8;j++){
			System.out.print("#"+(j+1)+" : ");
			for(int i=0;i<8;i++){
				System.out.print(temp64MergeKey[j][i]);
			}
			System.out.println();
		}
		System.out.println();
		System.out.println("Hex Key Value(K"+round_cnt+") : "+k.getHex(temp64MergeKey));
		System.out.println();
	

	}
	

}
